<template>
	<div class="flex flex-col w-full md:w-cart-register-md lg:w-720 mb-10">
		<div class="mx-4 md:mx-8 lg:mx-28">
			<h2 class="text-lg md:text-2xl font-primary-font-light pt-12 mb-8">
				Refills let you destroy year round. Sign up for auto-delivery and save.
			</h2>
			<div v-if="INACTIVE_SUBSCRIPTION.length == 1">
				<p class="text-sm md:text-base lg:text-sm">
					Box contains
					{{
						INACTIVE_SUBSCRIPTION[0].value.cart.obj.lineItems[0].description &&
						INACTIVE_SUBSCRIPTION[0].value.cart.obj.lineItems[0].description[locale]
					}}
				</p>
				<p class="text-sm md:text-base lg:text-sm">
					${{ INACTIVE_SUBSCRIPTION[0].value.cart.obj.lineItems[0].price.value.centAmount | centsToDollars }}
					per device every 6 months Next refill:
					{{ INACTIVE_SUBSCRIPTION[0].value.nextOrderDate | formatDateAurora('MM/DD/YY') }}
				</p>
			</div>
			<MkAddNewCreditcard class="mt-10 mb-14" />
			<MkToggleBtn
				:affirm="true"
				class="mb-10"
				:value="is_billing_address_toggled"
				:address="shippingAddress"
				@change="toggle_billing_address()"
			/>
			<MkAddressForm
				v-if="!is_billing_address_toggled"
				id="guest_billing_address_form"
				v-model="billingAddress"
				class="mb-10"
				:address-data="billingAddress"
			/>
			<p class="font-primary-font-light-italic mb-8">
				Filter auto-refills: Filters automatically renew at the end of each term. At renewal, you will be charged the
				same amount and for the same duration. You can
				<span
					ref="cancel_link"
					role="button"
					tabindex="0"
					class="font-primary-font-bold-italic md:font-primary-font-bold text-base leading-6 cursor-pointer focus:outline-none focus:ring-1 focus:ring-black"
					@click="showPopup()"
					@keypress.enter="showPopup()"
					>cancel</span
				>
				at any time.
			</p>
			<div class="flex flex-wrap items-center flex-col-reverse lg:flex-row justify-end">
				<NuxtLink
					:to="`/D2C/checkout/orderSuccess?order=${$route.query.order}&status=inactive`"
					class="font-primary-font-light text-sm leading-5 mk-link mt-8 md:mt-4 lg:mt-0"
					>I’ll do this later</NuxtLink
				>
				<MkSecondaryButton
					class="ml-0 lg:ml-10"
					button-title="Activate auto-refills"
					:loading="loading"
					@click="submit"
				/>
			</div>
		</div>
		<MkModal
			:toggle-modal="cancelModal && showModal"
			handel-shift-tab
			model-class="max-w-full md:max-w-md lg:max-w-xl items-center"
			@closeModal="closeModal"
		>
			<template #modalContent>
				<p class="font-primary-font-regular text-base">
					You can cancel or make changes to your auto-refill schedule in your account under Options. Changes to your
					auto-refill schedule must be made at least 1 day prior to your renewal date to avoid billing for the next
					renewal period. If you decide to stop auto-refills, you will continue to receive any shipments still
					outstanding in your current renewal period but will not be billed for another renewal period.
				</p>
			</template>
		</MkModal>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkAddressForm from '~/components/D2C/molecules/MkAddressForm.vue';
import MkAddNewCreditcard from '~/components/D2C/atoms/MkAddNewCreditcard.vue';
import MkToggleBtn from '~/components/D2C/atoms/MkToggleBtn.vue';
import MkSecondaryButton from '~/components/D2C/atoms/MkSecondaryButton.vue';
import MkModal from '~/components/D2C/molecules/MkModal.vue';
export default {
	name: 'MkAffirmAddressForm',
	components: {
		MkAddNewCreditcard,
		MkToggleBtn,
		MkAddressForm,
		MkSecondaryButton,
		MkModal,
	},
	data() {
		return {
			cancelModal: false,
			is_billing_address_toggled: true,
			shippingAddress: {
				streetAddress1: '',
				streetName: '',
				streetAddress2: '',
				city: '',
				postalCode: '',
				country: '',
			},
			billingAddress: {
				streetAddress1: '',
				streetAddress2: '',
				city: '',
				postalCode: '',
				country: '',
			},
			locale: 'en-US',
			loading: false,
		};
	},
	computed: {
		...mapState('CHECKOUT_STORE', ['INACTIVE_SUBSCRIPTION']),
		...mapState('USER_STORE', ['CUSTOMERID']),
		showModal() {
			return this.$store.state.MODAL_STORE.IS_ACTIVE;
		},
	},
	watch: {
		INACTIVE_SUBSCRIPTION() {
			this.setShipping();
		},
	},
	mounted() {
		this.setShipping();
	},
	methods: {
		closeModal() {
			this.cancelModal = false;
			this.$root.$utility.elementFocus(this, 'cancel_link');
		},
		showPopup() {
			this.cancelModal = true;
			this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
		},
		toggle_billing_address() {
			this.is_billing_address_toggled = !this.is_billing_address_toggled;
		},
		setShipping() {
			this.shippingAddress = this.INACTIVE_SUBSCRIPTION[0]?.value?.cart?.obj?.shippingAddress || this.shippingAddress;
		},
		async submit() {
			this.loading = true;
			const intentCallResponse = await this.$repositories.checkout.setupIntent({
				paymentKeyOnly: true,
				customerId: this.CUSTOMERID,
			});
			const clientSecret = (intentCallResponse.data && intentCallResponse.data.clientSecret) || '';
			const paymentIntentId = await getPaymentIntent(clientSecret); // eslint-disable-line
			const $payment = { paymentRequestBean: {} };
			if (paymentIntentId) {
				$payment.paymentRequestBean.billingAddress = this.is_billing_address_toggled
					? this.shippingAddress
					: this.billingAddress;
				$payment.paymentRequestBean.paymentToken = paymentIntentId;
				$payment.paymentRequestBean.shippingAsBillingAddress = this.is_billing_address_toggled;
				$payment.paymentType = 'CREDITCARD';
				$payment.paymentRequestBean.paymentPreferences = 'CREDITCARD';
				$payment.action = 'UPDATE_PAYMENT_OPTION';
				for (let $i = 0; $i < this.INACTIVE_SUBSCRIPTION.length; $i++) {
					await this.updateSubscription('TURN_ON', this.INACTIVE_SUBSCRIPTION[$i]);
					await this.updateSubscription('UPDATE_PAYMENT_OPTION', this.INACTIVE_SUBSCRIPTION[$i], $payment);
					await this.updateSubscription('UPDATE_SHIPPING_ADDRESS', this.INACTIVE_SUBSCRIPTION[$i]);
				}
				this.$router.push(`/D2C/checkout/orderSuccess?order=${this.$route.query.order}&status=activated`);
			}
			this.loading = false;
		},
		async updateSubscription($action, $subscriptoin, $payment) {
			const $data = {
				container: $subscriptoin.container,
				key: $subscriptoin.key,
				data: {
					action: $action,
				},
			};
			try {
				switch ($action) {
					case 'TURN_ON':
						$data.data.surveyQuestionId = this.turnOffRefillSelected;
						delete $data.data.updateCartRequestBean;
						break;
					case 'UPDATE_PAYMENT_OPTION':
						$data.data = $payment;
						break;
					case 'UPDATE_SHIPPING_ADDRESS':
						$data.data.updateCartRequestBean = {};
						$data.data.updateCartRequestBean.shippingAddress = this.shippingAddress;
						$data.data.updateCartRequestBean.action = 'SET_SHIPPING_ADDRESS';
						$data.data.shippingAddressId = this.shippingAddress.id;
						$data.data.shippingCarrierOptionsBean = {
							shippingAddress: this.shippingAddress,
						};
						break;
				}
				await this.$store.dispatch('USER_STORE/UPDATE_SUBSCRIPTION_QUANTITY', $data);
				this.loading = false;
			} catch (exp) {
				this.loading = false;
			}
		},
	},
};
</script>
